#include "cursormanager.hpp"

#include <fstream>
#include <sstream>

// Initialisation des attributs statiques
CursorManager * CursorManager::Instance = NULL;

/**
 * Constructeur
 */
Cursor::Cursor(std::string const & FileName)
{
    //TODO : gestion d'erreur...
    Uint8 * data, * mask;
    unsigned int width, height, hotx, hoty;
    int i = -1;
    std::string line;
    std::ifstream file(FileName.c_str());

    std::getline(file, line);
    std::istringstream(line) >> width >> height >> hotx >> hoty;

    data = new Uint8 [width * height / 8];
    mask = new Uint8 [width * height / 8];

    for (unsigned int row = 0; row < height; ++row)
    {
        std::getline(file, line);

        if (line.size() != width)
        {
            //TODO
        }

        for (unsigned int col = 0; col < width; ++col)
        {
            if (col % 8 != 0)
            {
                data[i] <<= 1;
                mask[i] <<= 1;
            }
            else
            {
                ++i;
                data[i] = mask[i] = 0;
            }

            switch (line[col])
            {
                case '1' :
                    data[i] |= 0x01;
                    mask[i] |= 0x01;
                    break;
                case '.' :
                    mask[i] |= 0x01;
                    break;
                case ' ' :
                    break;
            }
        }

    }

    CursorPointer = SDL_CreateCursor(data, mask, width, height, hotx, hoty);

    delete[] data;
    delete[] mask;
}

/**
 * Constructeur
 */
Cursor::Cursor()
{
    CursorPointer = SDL_GetCursor();
}

/**
 * Destructeur
 */
Cursor::~Cursor()
{
    SDL_FreeCursor(CursorPointer);
}

/**
 * Affiche le curseur
 */
void Cursor::setCursor() const
{
    SDL_SetCursor(CursorPointer);
}

void CursorManager::setCursor(const std::string & name)
{
    Cursor * MouseCursor;
    std::map<std::string, Cursor * >::iterator i;

    if (Instance == NULL)
    {
        Instance = new CursorManager();
        Instance->CursorList[""] = new Cursor();
    }

    i = Instance->CursorList.find(name);

    if(i == Instance->CursorList.end())
    {
        MouseCursor = new Cursor(name);
        Instance->CursorList[name] = MouseCursor;
    }
    else
    {
        MouseCursor = (*i).second;
    }

    MouseCursor->setCursor();
}

CursorManager::~CursorManager()
{
    std::map<std::string, Cursor * >::iterator i;

    for(i = CursorList.begin(); i != CursorList.end(); ++i)
    {
        delete (*i).second;
    }
}

CursorManager::CursorManager()
{}

