#include <iostream>
#include <sdl.h>
#include "cursormanager.hpp"

int main(int argc, char** argv)
{
    if (SDL_Init(SDL_INIT_VIDEO) < 0)
    {
        std::cerr << "Erreur  l'initialisation de la SDL : " << SDL_GetError() << std::endl;
        return EXIT_FAILURE;
    }

    SDL_Surface *ecran = SDL_SetVideoMode(800, 600, 32, SDL_HWSURFACE);
    if (ecran == NULL)
    {
        std::cerr << "SDL - Impossible d'activer le mode graphique : " << SDL_GetError() << std::endl;
        SDL_Quit();
        return EXIT_FAILURE;
    }

    SDL_WM_SetCaption("Test des curseurs SDL", NULL);

    SDL_Event event;
    bool quit = false;
    int position = 0;
    do
    {
        SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 60, 0, 0));
        SDL_Flip(ecran);

        while(SDL_PollEvent(&event))
        {
            switch (event.type)
            {
                case SDL_MOUSEMOTION :
                {
                    if(event.motion.x > 550 && position != 1)
                    {
                        position = 1;
                        CursorManager::setCursor("test1.txt");
                    }
                    else if (event.motion.x < 250 && position != 2)
                    {
                        position = 2;
                        CursorManager::setCursor("test2.txt");
                    }
                    else if (event.motion.x > 250 && event.motion.x < 550 && position != 3)
                    {
                        position = 3;
                        CursorManager::setCursor();
                    }
                    break;
                }
                case SDL_KEYDOWN :
                {
                    quit = true;
                    break;
                }
                case SDL_QUIT :
                {
                    quit = true;
                    break;
                }
                default :
                {
                    break;
                }
            }
        }
    }
    while (!quit);


    SDL_Quit();

    return EXIT_SUCCESS;
}
